#!usr/bin/python
# Draft for ToxAnalyzer in Python - Tables
# (c) 2019 - Daniel R. Rodrigues

import urllib.request as ur # library for getting data from the web
import sys # to raise a message to the user and then break the program
import pandas as pd


compound = input("Type the name of a chemical compound: ")

url = "http://ctdbase.org/tools/batchQuery.go?inputType=chem&inputTerms="+compound+"&report=genes_curated&format=tsv"

ctd_table = ur.urlopen(url)

ctd_table_opened = ctd_table.read().decode("utf-8")
'''
using decode() here because urls come in as bytes and I need to work
with strings, so a conversion is necessary...
https://stackoverflow.com/q/49731550
https://www.youtube.com/watch?v=5GzVNi0oTxQ
'''


if "Object not found" in ctd_table_opened:
    sys.exit("The database could not find the chemical you were looking for."
    "\nEither enter a valid chemical name or try again!")

# pandas doesnt need to decode the url to work, so im using the plain one!
pandas_table = pd.read_csv(url, sep="\t")

# removing the unnecessary columns
table_edited = pandas_table.drop(columns=["# Input", "CasRN", "ChemicalId"])

# removing the lines with missing values
table_edited = table_edited.dropna()

#orderning by organism name
table_edited_ordered = table_edited.sort_values(by="Organism")

# plotting the cleaned table
print(table_edited_ordered)

# generating data to plot as the stats of the compound
# gene_number = int(table_edited_ordered[['GeneSymbol']].count())
# organism_number = int(table_edited_ordered['Organism'].value_counts().count())
# publication_number = int(table_edited_ordered["PubMedIds"].str.split(pat="|").value_counts().count())
# PROBLEM WITH PUBLICATIONS HERE, IT IS PROBABLY WRONG

table_organism_gene_number = table_edited.groupby("Organism")["GeneSymbol"].value_counts()
table_organism_gene_number2 = table_edited.groupby("Organism")["GeneSymbol"].count()

print(table_organism_gene_number)
print(table_organism_gene_number2)
