#!usr/bin/python
# Draft for ToxAnalyzer in Python
# (c) 2019 - Daniel R. Rodrigues

import urllib.request as ur # library for getting data from the web
import sys # to raise a message to the user and then break the program
import pandas as pd


compound = input("Type the name of a chemical compound: ")

url = "http://ctdbase.org/tools/batchQuery.go?inputType=chem&inputTerms="+compound+"&report=genes_curated&format=tsv"

ctd_table = ur.urlopen(url)

ctd_table_opened = ctd_table.read().decode("utf-8")
'''
using decode() here because urls come in as bytes and I need to work
with strings, so a conversion is necessary...
https://stackoverflow.com/q/49731550
https://www.youtube.com/watch?v=5GzVNi0oTxQ
'''


if "Object not found" in ctd_table_opened:
    sys.exit("The database could not find the chemical you were looking for."
    "\nEither enter a valid chemical name or try again!")

# saving the table in a pandas dataframe
tabela_completa = pd.read_csv(url, sep="\t")

# removing the unnecessary columns
table_edited = tabela_completa.drop(columns=["# Input", "CasRN", "ChemicalId"])

# removing the lines with missing values
table_edited = table_edited.dropna()

#ordering by organism name
table_edited_ordered = table_edited.sort_values(by="Organism")

# generating the data to print the table to the user:
gene_number = int(table_edited_ordered[['GeneSymbol']].count())
organism_number = int(table_edited_ordered['Organism'].value_counts().count())

# printing data about the number of genes and organisms
print("\nOverview about "+compound+": ")
print(str(gene_number)+" genes.")
print("---------------")
print(str(organism_number)+" organisms.")
print("---------------")

publication_number = table_edited_ordered["PubMedIds"]

# if there's a pipe, we must have a workaround...
if "|" in publication_number == "True":
    publication_number = table_edited_ordered["PubMedIds"].str.split(pat = "|") # there was a problem counting here

    # fixing the counting problem! THIS SOLUTION I CAME UP WITH!!!
    number_of_publications = []
    for publication in publication_number:
        if len(list(publication)) > 1:
            for pub in publication:
                number_of_publications.append(pub)
        else:
            number_of_publications.extend(publication)
        publication_number = (len(set(number_of_publications)))
        print(str(publication_number)+" publications.")


else: # if there's no pipe, we just need to count
    publication_number = table_edited_ordered["PubMedIds"].value_counts().count()
print(str(publication_number)+" publications.")
# removing duplicates and counting
# publication_number = (len(set(number_of_publications)))

# printing the Overview data...
# print("\nOverview about "+compound+": ")
# print(str(gene_number)+" genes.")
# print("---------------")
# print(str(organism_number)+" organisms.")
# print("---------------")
# print(str(publication_number)+" publications.")
#
# print(publication_number)
