#!usr/bin/python
# Draft for ToxAnalyzer in Python
# (c) 2019 - Daniel R. Rodrigues

import urllib.request as ur # library for getting data from the web
import sys # to raise a message to the user and then break the program
import matplotlib.pyplot as plt
import numpy as np


compound = input("Type the name of a chemical compound: ")

url = "http://ctdbase.org/tools/batchQuery.go?inputType=chem&inputTerms="+compound+"&report=genes_curated&format=tsv"

ctd_table = ur.urlopen(url)

ctd_table_opened = ctd_table.read().decode("utf-8")
'''
using decode() here because urls come in as bytes and I need to work
with strings, so a conversion is necessary...
https://stackoverflow.com/q/49731550
https://www.youtube.com/watch?v=5GzVNi0oTxQ
'''


if "Object not found" in ctd_table_opened:
    sys.exit("The database could not find the chemical you were looking for."
    "\nEither enter a valid chemical name or try again!")

#splitting the table generated from the server
table_splitted = ctd_table_opened.split("\t")
table_splitted_num = len(table_splitted) # getting the list size

organism_count = 14 # problems with magic numbers here
# number where the first organism appear!
organisms = [] # creating a list to be filled

while organism_count < table_splitted_num:
    organisms.append(table_splitted[organism_count])
    organism_count += 8 # problems with magic numbers



genes_per_organism = {} #dictionary to store organisms and their gene numbers

# while i < int(len(organisms)): # FORMA FEIA DE FAZER AS COISAS
#     genes_per_organism[organisms[i]] = 0
#     while j < int(len(organisms)):
#         genes_per_organism[organisms[j]] = 0
#         if genes_per_organism[organisms[i]] == genes_per_organism[organisms[j]]:
#             genes_per_organism[organisms[i]] += 1
#         j += 1
#     i += 1

# creating the dictionary of organisms and their gene numbers
for organism in organisms: # from https://stackoverflow.com/a/1692428
    if not organism in genes_per_organism:
        genes_per_organism[organism] = 1
    if organism == "": # removing genes without organisms
         genes_per_organism.pop("")
    else:
        genes_per_organism[organism] += 1

#print(genes_per_organism)


# printando o gráfico
# https://python-graph-gallery.com/2-horizontal-barplot/
# https://www.youtube.com/watch?v=sCaGYsEYy-k&list=PLQVvvaa0QuDe8XSftW-RAxdo6OmaeL85M&index=50
names = list(genes_per_organism.values())
bars = list(genes_per_organism.keys())
y_pos = np.arange(len(bars))

plt.barh(y_pos, names)
plt.yticks(y_pos, bars)

plt.title("Number of genes interating with "+compound+" in different organisms")
#plt.ylabel("Organisms")
plt.xlabel("Number of genes")

plt.show()
